import os
import pathlib
import zipfile


class RecursiveZipper:

    def __init__(self, folderPath, targetFolderPath, compress_type=zipfile.ZIP_DEFLATED):
        self.folderPath = pathlib.Path(folderPath)
        self.name = self.folderPath.name
        self.targetFolderPath = pathlib.Path(targetFolderPath)
        self.compress_type = compress_type

    def zip(self):

        target = self.targetFolderPath.joinpath(self.name + '.zip')
        if not target.parent.exists():
            target.parent.mkdir()

        with zipfile.ZipFile(target.__str__(), mode='w') as zipFile:
            for folder, subfolders, files in os.walk(self.folderPath):
                for file in files:
                    path = os.path.join(folder, file)
                    acfile = '/'.join(path.split('/')[1:]) # better way to do so … to lazy. gotta go!""
                    zipFile.write(path, acfile ,compress_type=self.compress_type)
